﻿using Syncfusion.Windows.PropertyGrid;
using Syncfusion.Windows.Shared;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace PropertyGridCustomObjectSample
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.propertyGrid.SelectedObject = new Customer();
            
          
            
        }

    
        void ItemContainerGenerator_StatusChanged(object sender, EventArgs e)
        {
            foreach (PropertyCatagoryViewItem item in VisualUtils.EnumChildrenOfType(this, typeof(PropertyCatagoryViewItem)))
            {
                item.IsExpanded = true;
                foreach (var items in item.Items)
                {
                    foreach (PropertyViewItem propertyviewitem in VisualUtils.EnumChildrenOfType(this, typeof(PropertyViewItem)))
                    {
                        ToggleButton button = (ToggleButton)propertyviewitem.Template.FindName("PART_Toggle", propertyviewitem);
                        if (button.Visibility == System.Windows.Visibility.Visible)
                        {
                            button.IsChecked = true;
                        }
                    }
                               
                }
            }
         
        }

      
        private void propertyGrid_Loaded(object sender, RoutedEventArgs e)
        {
            PropertyView item1 = VisualUtils.FindDescendant(this, typeof(PropertyView)) as PropertyView;

            if(item1!=null)
            item1.ItemContainerGenerator.StatusChanged+=ItemContainerGenerator_StatusChanged;

           
        }

        
    }
    public class Customer
    {
        private string _name;
        private int _age;
        private DateTime _dateOfBirth;
        private string _SSN;
        private string _address;
        private string _email;
        private bool _frequentBuyer;
        private ObservableCollection<Person> person;
        public Customer()
        {
            person = new ObservableCollection<Person>()
         {
             new Person(){Name="Prabhat",Address="India"},
             new Person(){Name="Smith",Address="US"}
         };
            _name = "Sugapriya";
            _age = 22;
            _dateOfBirth = new DateTime(21/02/1993);



        }
        [CategoryAttribute("ID Settings"), DescriptionAttribute("Name of the customer")]
        public string Name
        {
            get
            {
                return _name;
            }
            set
            {
                _name = value;
            }
        }
 
        [CategoryAttribute("ID Settings"),
        DescriptionAttribute("Social Security Number of the customer")]
        public string SSN
        {
            get
            {
                return _SSN;
            }
            set
            {
                _SSN = value;
            }
        }
        [CategoryAttribute("ID Settings"),
        DescriptionAttribute("Address of the customer")]
        public string Address
        {
            get
            {
                return _address;
            }
            set
            {
                _address = value;
            }
        }
        [CategoryAttribute("ID Settings"),
        DescriptionAttribute("Date of Birth of the Customer (optional)")]
        public DateTime DateOfBirth
        {
            get
            {
                return _dateOfBirth;
            }
            set
            {
                _dateOfBirth = value;
            }
        }
        [CategoryAttribute("ID Settings"), DescriptionAttribute("Age of the customer")]
        public int Age
        {
            get
            {
                return _age;
            }
            set
            {
                _age = value;
            }
        }
        [CategoryAttribute("Marketting Settings"), DescriptionAttribute("If the customer as bought more than 10 times, this is set to true")]
        public bool FrequentBuyer
        {
            get
            {
                return _frequentBuyer;
            }
            set
            {
                _frequentBuyer = value;
            }
        }
        [CategoryAttribute("Marketting Settings"), DescriptionAttribute("Most current e-mail of the customer")]
        public string Email
        {
            get
            {
                return _email;
            }
            set
            {
                _email = value;
            }
        }
    }
    
    
    public class Person
    {
        public string Name { get; set; }
        public string Address { get; set; }
    } 
 
}
